Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/16_nesting.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/16_nesting.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/16_nesting.expect	(revision 331)
@@ -0,0 +1,18 @@
+0 0 0
+0 0 1
+0 0 2
+0 1 0
+0 1 1
+0 1 2
+0 2 0
+0 2 1
+0 2 2
+1 0 0
+1 0 1
+1 0 2
+1 1 0
+1 1 1
+1 1 2
+1 2 0
+1 2 1
+1 2 2
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/17_enum.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/17_enum.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/17_enum.c	(revision 331)
@@ -0,0 +1,72 @@
+#include <stdio.h>
+
+enum fred
+{
+   a,
+   b,
+   c,
+   d,
+   e = 54,
+   f = 73,
+   g,
+   h
+};
+
+/* All following uses of enum efoo should compile
+   without warning.  While forward enums aren't ISO C,
+   it's accepted by GCC also in strict mode, and only warned
+   about with -pedantic.  This happens in the real world.  */
+/* Strict ISO C doesn't allow this kind of forward declaration of
+   enums, but GCC accepts it (and gives only pedantic warning), and
+   it occurs in the wild.  */
+enum efoo;
+struct Sforward_use {
+    int (*fmember) (enum efoo x);
+};
+
+extern enum efoo it_real_fn(void);
+enum efoo {
+  ONE,
+  TWO,
+};
+struct S2 {
+  enum efoo (*f2) (void);
+};
+void should_compile(struct S2 *s)
+{
+  s->f2 = it_real_fn;
+}
+
+enum efoo it_real_fn(void)
+{
+  return TWO;
+}
+
+static unsigned int deref_uintptr(unsigned int *p)
+{
+  return *p;
+}
+
+enum Epositive {
+    epos_one, epos_two
+};
+
+int main()
+{
+   enum fred frod;
+   enum Epositive epos = epos_two;
+
+   printf("%d %d %d %d %d %d %d %d\n", a, b, c, d, e, f, g, h);
+   /* printf("%d\n", frod); */
+   frod = 12;
+   printf("%d\n", frod);
+   frod = e;
+   printf("%d\n", frod);
+
+   /* Following should compile without warning.  */
+   printf ("enum to int: %u\n", deref_uintptr(&epos));
+
+   return 0;
+}
+
+/* vim: set expandtab ts=4 sw=3 sts=3 tw=80 :*/
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/17_enum.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/17_enum.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/17_enum.expect	(revision 331)
@@ -0,0 +1,4 @@
+0 1 2 3 54 73 74 75
+12
+54
+enum to int: 1
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/18_include.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/18_include.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/18_include.c	(revision 331)
@@ -0,0 +1,12 @@
+#include <stdio.h>
+
+int main()
+{
+   printf("including\n");
+#include "18_include.h"
+   printf("done\n");
+
+   return 0;
+}
+
+/* vim: set expandtab ts=4 sw=3 sts=3 tw=80 :*/
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/18_include.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/18_include.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/18_include.expect	(revision 331)
@@ -0,0 +1,3 @@
+including
+included
+done
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/18_include.h
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/18_include.h	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/18_include.h	(revision 331)
@@ -0,0 +1,1 @@
+printf("included\n");
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/19_pointer_arithmetic.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/19_pointer_arithmetic.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/19_pointer_arithmetic.c	(revision 331)
@@ -0,0 +1,28 @@
+#include <stdio.h>
+
+int main()
+{
+   int a;
+   int *b;
+   int *c;
+
+   a = 42;
+   b = &a;
+   c = NULL;
+
+   printf("%d\n", *b);
+
+   if (b == NULL)
+      printf("b is NULL\n");
+   else
+      printf("b is not NULL\n");
+
+   if (c == NULL)
+      printf("c is NULL\n");
+   else
+      printf("c is not NULL\n");
+
+   return 0;
+}
+
+/* vim: set expandtab ts=4 sw=3 sts=3 tw=80 :*/
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/19_pointer_arithmetic.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/19_pointer_arithmetic.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/19_pointer_arithmetic.expect	(revision 331)
@@ -0,0 +1,3 @@
+42
+b is not NULL
+c is NULL
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/20_pointer_comparison.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/20_pointer_comparison.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/20_pointer_comparison.c	(revision 331)
@@ -0,0 +1,24 @@
+#include <stdio.h>
+
+int main()
+{
+   int a;
+   int b;
+   int *d;
+   int *e;
+   d = &a;
+   e = &b;
+   a = 12;
+   b = 34;
+   printf("%d\n", *d);
+   printf("%d\n", *e);
+   printf("%d\n", d == e);
+   printf("%d\n", d != e);
+   d = e;
+   printf("%d\n", d == e);
+   printf("%d\n", d != e);
+
+   return 0;
+}
+
+/* vim: set expandtab ts=4 sw=3 sts=3 tw=80 :*/
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/20_pointer_comparison.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/20_pointer_comparison.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/20_pointer_comparison.expect	(revision 331)
@@ -0,0 +1,6 @@
+12
+34
+0
+1
+1
+0
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/21_char_array.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/21_char_array.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/21_char_array.c	(revision 331)
@@ -0,0 +1,33 @@
+#include <stdio.h>
+
+int main()
+{
+   int x = 'a';
+   char y = x;
+
+   char *a = "hello";
+
+   printf("%s\n", a);
+
+   int c;
+   c = *a;
+
+   char *b;
+   for (b = a; *b != 0; b++)
+      printf("%c: %d\n", *b, *b);
+
+   char destarray[10];
+   char *dest = &destarray[0];
+   char *src = a;
+
+   while (*src != 0)
+      *dest++ = *src++;
+
+   *dest = 0;
+
+   printf("copied string is %s\n", destarray);
+
+   return 0;
+}
+
+/* vim: set expandtab ts=4 sw=3 sts=3 tw=80 :*/
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/21_char_array.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/21_char_array.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/21_char_array.expect	(revision 331)
@@ -0,0 +1,7 @@
+hello
+h: 104
+e: 101
+l: 108
+l: 108
+o: 111
+copied string is hello
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/22_floating_point.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/22_floating_point.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/22_floating_point.c	(revision 331)
@@ -0,0 +1,50 @@
+#include <stdio.h>
+#include <math.h>
+
+int main()
+{
+   // variables
+   float a = 12.34 + 56.78;
+   printf("%f\n", a);
+
+   // infix operators
+   printf("%f\n", 12.34 + 56.78);
+   printf("%f\n", 12.34 - 56.78);
+   printf("%f\n", 12.34 * 56.78);
+   printf("%f\n", 12.34 / 56.78);
+
+   // comparison operators
+   printf("%d %d %d %d %d %d\n", 12.34 < 56.78, 12.34 <= 56.78, 12.34 == 56.78, 12.34 >= 56.78, 12.34 > 56.78, 12.34 != 56.78);
+   printf("%d %d %d %d %d %d\n", 12.34 < 12.34, 12.34 <= 12.34, 12.34 == 12.34, 12.34 >= 12.34, 12.34 > 12.34, 12.34 != 12.34);
+   printf("%d %d %d %d %d %d\n", 56.78 < 12.34, 56.78 <= 12.34, 56.78 == 12.34, 56.78 >= 12.34, 56.78 > 12.34, 56.78 != 12.34);
+
+   // assignment operators
+   a = 12.34;
+   a += 56.78;
+   printf("%f\n", a);
+
+   a = 12.34;
+   a -= 56.78;
+   printf("%f\n", a);
+
+   a = 12.34;
+   a *= 56.78;
+   printf("%f\n", a);
+
+   a = 12.34;
+   a /= 56.78;
+   printf("%f\n", a);
+
+   // prefix operators
+   printf("%f\n", +12.34);
+   printf("%f\n", -12.34);
+
+   // type coercion
+   a = 2;
+   printf("%f\n", a);
+   printf("%f\n", sin(2));
+
+   return 0;
+}
+
+/* vim: set expandtab ts=4 sw=3 sts=3 tw=80 :*/
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/22_floating_point.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/22_floating_point.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/22_floating_point.expect	(revision 331)
@@ -0,0 +1,16 @@
+69.120003
+69.120000
+-44.440000
+700.665200
+0.217330
+1 1 0 0 0 1
+0 1 1 1 0 0
+0 0 0 1 1 1
+69.120003
+-44.439999
+700.665222
+0.217330
+12.340000
+-12.340000
+2.000000
+0.909297
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/23_type_coercion.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/23_type_coercion.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/23_type_coercion.c	(revision 331)
@@ -0,0 +1,54 @@
+#include <stdio.h>
+
+void charfunc(char a)
+{
+   printf("char: %c\n", a);
+}
+
+void intfunc(int a)
+{
+   printf("int: %d\n", a);
+}
+
+void floatfunc(float a)
+{
+   printf("float: %f\n", a);
+}
+
+int main()
+{
+   charfunc('a');
+   charfunc(98);
+   charfunc(99.0);
+
+   intfunc('a');
+   intfunc(98);
+   intfunc(99.0);
+
+   floatfunc('a');
+   floatfunc(98);
+   floatfunc(99.0);
+
+   /* printf("%c %d %f\n", 'a', 'b', 'c'); */
+   /* printf("%c %d %f\n", 97, 98, 99); */
+   /* printf("%c %d %f\n", 97.0, 98.0, 99.0); */
+
+   char b = 97;
+   char c = 97.0;
+
+   printf("%d %d\n", b, c);
+
+   int d = 'a';
+   int e = 97.0;
+
+   printf("%d %d\n", d, e);
+
+   float f = 'a';
+   float g = 97;
+
+   printf("%f %f\n", f, g);
+
+   return 0;
+}
+
+/* vim: set expandtab ts=4 sw=3 sts=3 tw=80 :*/
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/23_type_coercion.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/23_type_coercion.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/23_type_coercion.expect	(revision 331)
@@ -0,0 +1,12 @@
+char: a
+char: b
+char: c
+int: 97
+int: 98
+int: 99
+float: 97.000000
+float: 98.000000
+float: 99.000000
+97 97
+97 97
+97.000000 97.000000
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/24_math_library.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/24_math_library.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/24_math_library.c	(revision 331)
@@ -0,0 +1,30 @@
+#define _ISOC99_SOURCE 1
+
+#include <stdio.h>
+#include <math.h>
+
+int main()
+{
+   printf("%f\n", sin(0.12));
+   printf("%f\n", cos(0.12));
+   printf("%f\n", tan(0.12));
+   printf("%f\n", asin(0.12));
+   printf("%f\n", acos(0.12));
+   printf("%f\n", atan(0.12));
+   printf("%f\n", sinh(0.12));
+   printf("%f\n", cosh(0.12));
+   printf("%f\n", tanh(0.12));
+   printf("%f\n", exp(0.12));
+   printf("%f\n", fabs(-0.12));
+   printf("%f\n", log(0.12));
+   printf("%f\n", log10(0.12));
+   printf("%f\n", pow(0.12, 0.12));
+   printf("%f\n", sqrt(0.12));
+   printf("%f\n", round(12.34));
+   printf("%f\n", ceil(12.34));
+   printf("%f\n", floor(12.34));
+
+   return 0;
+}
+
+/* vim: set expandtab ts=4 sw=3 sts=3 tw=80 :*/
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/24_math_library.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/24_math_library.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/24_math_library.expect	(revision 331)
@@ -0,0 +1,18 @@
+0.119712
+0.992809
+0.120579
+0.120290
+1.450506
+0.119429
+0.120288
+1.007209
+0.119427
+1.127497
+0.120000
+-2.120264
+-0.920819
+0.775357
+0.346410
+12.000000
+13.000000
+12.000000
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/25_quicksort.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/25_quicksort.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/25_quicksort.c	(revision 331)
@@ -0,0 +1,83 @@
+#include <stdio.h>
+
+int array[16];
+
+//Swap integer values by array indexes
+void swap(int a, int b)
+{
+   int tmp  = array[a];
+   array[a] = array[b];
+   array[b] = tmp;
+}
+
+//Partition the array into two halves and return the
+//index about which the array is partitioned
+int partition(int left, int right)
+{
+   int pivotIndex = left;
+   int pivotValue = array[pivotIndex];
+   int index = left;
+   int i;
+
+   swap(pivotIndex, right);
+   for(i = left; i < right; i++)
+   {
+      if(array[i] < pivotValue)
+      {
+         swap(i, index);
+         index += 1;
+      }
+   }
+   swap(right, index);
+
+   return index;
+}
+
+//Quicksort the array
+void quicksort(int left, int right)
+{
+   if(left >= right)
+      return;
+
+   int index = partition(left, right);
+   quicksort(left, index - 1);
+   quicksort(index + 1, right);
+}
+
+int main()
+{
+   int i;
+
+   array[0] = 62;
+   array[1] = 83;
+   array[2] = 4;
+   array[3] = 89;
+   array[4] = 36;
+   array[5] = 21;
+   array[6] = 74;
+   array[7] = 37;
+   array[8] = 65;
+   array[9] = 33;
+   array[10] = 96;
+   array[11] = 38;
+   array[12] = 53;
+   array[13] = 16;
+   array[14] = 74;
+   array[15] = 55;
+
+   for (i = 0; i < 16; i++)
+      printf("%d ", array[i]);
+
+   printf("\n");
+
+   quicksort(0, 15);
+
+   for (i = 0; i < 16; i++)
+      printf("%d ", array[i]);
+
+   printf("\n");
+
+   return 0;
+}
+
+/* vim: set expandtab ts=4 sw=3 sts=3 tw=80 :*/
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/25_quicksort.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/25_quicksort.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/25_quicksort.expect	(revision 331)
@@ -0,0 +1,2 @@
+62 83 4 89 36 21 74 37 65 33 96 38 53 16 74 55 
+4 16 21 33 36 37 38 53 55 62 65 74 74 83 89 96 
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/26_character_constants.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/26_character_constants.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/26_character_constants.c	(revision 331)
@@ -0,0 +1,17 @@
+#include <stdio.h>
+
+int main()
+{
+   printf("%d\n", '\1');
+   printf("%d\n", '\10');
+   printf("%d\n", '\100');
+   printf("%d\n", '\x01');
+   printf("%d\n", '\x0e');
+   printf("%d\n", '\x10');
+   printf("%d\n", '\x40');
+   printf("test \x40\n");
+
+   return 0;
+}
+
+/* vim: set expandtab ts=4 sw=3 sts=3 tw=80 :*/
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/26_character_constants.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/26_character_constants.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/26_character_constants.expect	(revision 331)
@@ -0,0 +1,8 @@
+1
+8
+64
+1
+14
+16
+64
+test @
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/27_sizeof.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/27_sizeof.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/27_sizeof.c	(revision 331)
@@ -0,0 +1,18 @@
+#include <stdio.h>
+
+int main()
+{
+   char a;
+   int b;
+   double c;
+
+   printf("%d\n", sizeof(a));
+   printf("%d\n", sizeof(b));
+   printf("%d\n", sizeof(c));
+
+   printf("%d\n", sizeof(!a));
+
+   return 0;
+}
+
+/* vim: set expandtab ts=4 sw=3 sts=3 tw=80 :*/
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/27_sizeof.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/27_sizeof.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/27_sizeof.expect	(revision 331)
@@ -0,0 +1,4 @@
+1
+4
+8
+4
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/28_strings.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/28_strings.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/28_strings.c	(revision 331)
@@ -0,0 +1,45 @@
+#include <stdio.h>
+#include <string.h>
+
+int main()
+{
+   char a[10];
+
+   strcpy(a, "hello");
+   printf("%s\n", a);
+
+   strncpy(a, "gosh", 2);
+   printf("%s\n", a);
+
+   printf("%d\n", strcmp(a, "apple") > 0);
+   printf("%d\n", strcmp(a, "goere") > 0);
+   printf("%d\n", strcmp(a, "zebra") < 0);
+
+   printf("%d\n", strlen(a));
+
+   strcat(a, "!");
+   printf("%s\n", a);
+
+   printf("%d\n", strncmp(a, "apple", 2) > 0);
+   printf("%d\n", strncmp(a, "goere", 2) == 0);
+   printf("%d\n", strncmp(a, "goerg", 2) == 0);
+   printf("%d\n", strncmp(a, "zebra", 2) < 0);
+
+   printf("%s\n", strchr(a, 'o'));
+   printf("%s\n", strrchr(a, 'l'));
+   printf("%d\n", strrchr(a, 'x') == NULL);
+
+   memset(&a[1], 'r', 4);
+   printf("%s\n", a);
+
+   memcpy(&a[2], a, 2);
+   printf("%s\n", a);
+
+   printf("%d\n", memcmp(a, "apple", 4) > 0);
+   printf("%d\n", memcmp(a, "grgr", 4) == 0);
+   printf("%d\n", memcmp(a, "zebra", 4) < 0);
+
+   return 0;
+}
+
+/* vim: set expandtab ts=4 sw=3 sts=3 tw=80 :*/
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/28_strings.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/28_strings.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/28_strings.expect	(revision 331)
@@ -0,0 +1,19 @@
+hello
+gollo
+1
+1
+1
+5
+gollo!
+1
+1
+1
+1
+ollo!
+lo!
+1
+grrrr!
+grgrr!
+1
+1
+1
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/29_array_address.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/29_array_address.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/29_array_address.c	(revision 331)
@@ -0,0 +1,13 @@
+#include <stdio.h>
+#include <string.h>
+
+int main()
+{
+   char a[10];
+   strcpy(a, "abcdef");
+   printf("%s\n", &a[1]);
+
+   return 0;
+}
+
+/* vim: set expandtab ts=4 sw=3 sts=3 tw=80 :*/
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/29_array_address.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/29_array_address.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/29_array_address.expect	(revision 331)
@@ -0,0 +1,1 @@
+bcdef
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/30_hanoi.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/30_hanoi.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/30_hanoi.c	(revision 331)
@@ -0,0 +1,122 @@
+/* example from http://barnyard.syr.edu/quickies/hanoi.c */
+
+/* hanoi.c: solves the tower of hanoi problem. (Programming exercise.) */
+/* By Terry R. McConnell (12/2/97) */
+/* Compile: cc -o hanoi hanoi.c */
+
+/* This program does no error checking. But then, if it's right, 
+   it's right ... right ? */
+
+
+/* The original towers of hanoi problem seems to have been originally posed
+   by one M. Claus in 1883. There is a popular legend that goes along with
+   it that has been often repeated and paraphrased. It goes something like this:
+   In the great temple at Benares there are 3 golden spikes. On one of them,
+   God placed 64 disks increasing in size from bottom to top, at the beginning
+   of time. Since then, and to this day, the priest on duty constantly transfers
+   disks, one at a time, in such a way that no larger disk is ever put on top
+   of a smaller one. When the disks have been transferred entirely to another
+   spike the Universe will come to an end in a large thunderclap.
+
+   This paraphrases the original legend due to DeParville, La Nature, Paris 1884,
+   Part I, 285-286. For this and further information see: Mathematical 
+   Recreations & Essays, W.W. Rouse Ball, MacMillan, NewYork, 11th Ed. 1967,
+   303-305.
+ *
+ *
+ */
+
+#include <stdio.h>
+#include <stdlib.h>
+
+#define TRUE 1
+#define FALSE 0
+
+/* This is the number of "disks" on tower A initially. Taken to be 64 in the
+ * legend. The number of moves required, in general, is 2^N - 1. For N = 64,
+ * this is 18,446,744,073,709,551,615 */
+#define N 4
+
+/* These are the three towers. For example if the state of A is 0,1,3,4, that
+ * means that there are three discs on A of sizes 1, 3, and 4. (Think of right
+ * as being the "down" direction.) */
+int A[N], B[N], C[N]; 
+
+void Hanoi(int,int*,int*,int*);
+
+/* Print the current configuration of A, B, and C to the screen */
+void PrintAll()
+{
+   int i;
+
+   printf("A: ");
+   for(i=0;i<N;i++)printf(" %d ",A[i]);
+   printf("\n");
+
+   printf("B: ");
+   for(i=0;i<N;i++)printf(" %d ",B[i]);
+   printf("\n");
+
+   printf("C: ");
+   for(i=0;i<N;i++)printf(" %d ",C[i]);
+   printf("\n");
+   printf("------------------------------------------\n");
+   return;
+}
+
+/* Move the leftmost nonzero element of source to dest, leave behind 0. */
+/* Returns the value moved (not used.) */
+int Move(int *source, int *dest)
+{
+   int i = 0, j = 0;
+
+   while (i<N && (source[i])==0) i++;
+   while (j<N && (dest[j])==0) j++;
+
+   dest[j-1] = source[i];
+   source[i] = 0;
+   PrintAll();       /* Print configuration after each move. */
+   return dest[j-1];
+}
+
+
+/* Moves first n nonzero numbers from source to dest using the rules of Hanoi.
+   Calls itself recursively.
+   */
+void Hanoi(int n,int *source, int *dest, int *spare)
+{
+   int i;
+   if(n==1){
+      Move(source,dest);
+      return;
+   }
+
+   Hanoi(n-1,source,spare,dest);
+   Move(source,dest);
+   Hanoi(n-1,spare,dest,source);	
+   return;
+}
+
+int main()
+{
+   int i;
+
+   /* initialize the towers */
+   for(i=0;i<N;i++)A[i]=i+1;
+   for(i=0;i<N;i++)B[i]=0;
+   for(i=0;i<N;i++)C[i]=0;
+
+   printf("Solution of Tower of Hanoi Problem with %d Disks\n\n",N);
+
+   /* Print the starting state */
+   printf("Starting state:\n");
+   PrintAll();
+   printf("\n\nSubsequent states:\n\n");
+
+   /* Do it! Use A = Source, B = Destination, C = Spare */
+   Hanoi(N,A,B,C);
+
+   return 0;
+}
+
+/* vim: set expandtab ts=4 sw=3 sts=3 tw=80 :*/
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/30_hanoi.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/30_hanoi.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/30_hanoi.expect	(revision 331)
@@ -0,0 +1,71 @@
+Solution of Tower of Hanoi Problem with 4 Disks
+
+Starting state:
+A:  1  2  3  4 
+B:  0  0  0  0 
+C:  0  0  0  0 
+------------------------------------------
+
+
+Subsequent states:
+
+A:  0  2  3  4 
+B:  0  0  0  0 
+C:  0  0  0  1 
+------------------------------------------
+A:  0  0  3  4 
+B:  0  0  0  2 
+C:  0  0  0  1 
+------------------------------------------
+A:  0  0  3  4 
+B:  0  0  1  2 
+C:  0  0  0  0 
+------------------------------------------
+A:  0  0  0  4 
+B:  0  0  1  2 
+C:  0  0  0  3 
+------------------------------------------
+A:  0  0  1  4 
+B:  0  0  0  2 
+C:  0  0  0  3 
+------------------------------------------
+A:  0  0  1  4 
+B:  0  0  0  0 
+C:  0  0  2  3 
+------------------------------------------
+A:  0  0  0  4 
+B:  0  0  0  0 
+C:  0  1  2  3 
+------------------------------------------
+A:  0  0  0  0 
+B:  0  0  0  4 
+C:  0  1  2  3 
+------------------------------------------
+A:  0  0  0  0 
+B:  0  0  1  4 
+C:  0  0  2  3 
+------------------------------------------
+A:  0  0  0  2 
+B:  0  0  1  4 
+C:  0  0  0  3 
+------------------------------------------
+A:  0  0  1  2 
+B:  0  0  0  4 
+C:  0  0  0  3 
+------------------------------------------
+A:  0  0  1  2 
+B:  0  0  3  4 
+C:  0  0  0  0 
+------------------------------------------
+A:  0  0  0  2 
+B:  0  0  3  4 
+C:  0  0  0  1 
+------------------------------------------
+A:  0  0  0  0 
+B:  0  2  3  4 
+C:  0  0  0  1 
+------------------------------------------
+A:  0  0  0  0 
+B:  1  2  3  4 
+C:  0  0  0  0 
+------------------------------------------
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/31_args.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/31_args.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/31_args.c	(revision 331)
@@ -0,0 +1,14 @@
+#include <stdio.h>
+
+int main(int argc, char **argv)
+{
+   int Count;
+
+   printf("hello world %d\n", argc);
+   for (Count = 1; Count < argc; Count++)
+      printf("arg %d: %s\n", Count, argv[Count]);
+
+   return 0;
+}
+
+/* vim: set expandtab ts=4 sw=3 sts=3 tw=80 :*/
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/31_args.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/31_args.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/31_args.expect	(revision 331)
@@ -0,0 +1,6 @@
+hello world 6
+arg 1: arg1
+arg 2: arg2
+arg 3: arg3
+arg 4: arg4
+arg 5: arg5
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/32_led.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/32_led.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/32_led.c	(revision 331)
@@ -0,0 +1,266 @@
+/* example from http://barnyard.syr.edu/quickies/led.c */
+
+/* led.c: print out number as if on 7 line led display. I.e., write integer
+   given on command line like this:  
+      _   _       _  
+   |  _|  _| |_| |_  
+   | |_   _|   |  _| etc.
+
+   We assume the terminal behaves like a classical teletype. So the top
+   lines of all digits have to be printed first, then the middle lines of
+   all digits, etc.
+
+   By Terry R. McConnell
+
+compile: cc -o led led.c
+
+If you just want to link in the subroutine print_led that does all the
+work, compile with -DNO_MAIN, and declare the following in any source file
+that uses the call:
+
+extern void print_led(unsigned long x, char *buf);
+
+Bug: you cannot call repeatedly to print more than one number to a line.
+That would require curses or some other terminal API that allows moving the
+cursor to a previous line.
+
+*/
+
+
+
+#include <stdlib.h>
+#include <stdio.h>
+
+#define MAX_DIGITS 32
+#define NO_MAIN
+
+
+/* Print the top line of the digit d into buffer. 
+   Does not null terminate buffer. */
+
+void topline(int d, char *p){
+
+   *p++ = ' ';
+   switch(d){
+
+      /* all these have _ on top line */
+
+      case 0:
+      case 2:
+      case 3:
+      case 5:
+      case 7:
+      case 8:
+      case 9:
+         *p++ = '_';
+         break;
+      default:
+         *p++=' ';
+
+   }
+   *p++=' ';
+}
+
+/* Print the middle line of the digit d into the buffer. 
+   Does not null terminate. */
+
+void midline(int d, char *p){
+
+   switch(d){
+
+      /* those that have leading | on middle line */
+
+      case 0:
+      case 4:
+      case 5:
+      case 6:
+      case 8:
+      case 9:
+         *p++='|';
+         break;
+      default:
+         *p++=' ';	
+   }
+   switch(d){
+
+      /* those that have _ on middle line */
+
+      case 2:
+      case 3:
+      case 4:
+      case 5:
+      case 6:
+      case 8:
+      case 9:
+         *p++='_';
+         break;
+      default:
+         *p++=' ';
+
+   }
+   switch(d){
+
+      /* those that have closing | on middle line */
+
+      case 0:
+      case 1:
+      case 2:
+      case 3:
+      case 4:
+      case 7:
+      case 8:
+      case 9:
+         *p++='|';
+         break;
+      default:
+         *p++=' ';
+
+   }
+}
+
+/* Print the bottom line of the digit d. Does not null terminate. */
+
+void botline(int d, char *p){
+
+
+   switch(d){
+
+      /* those that have leading | on bottom line */
+
+      case 0:
+      case 2:
+      case 6:
+      case 8:
+         *p++='|';
+         break;
+      default:
+         *p++=' ';	
+   }
+   switch(d){
+
+      /* those that have _ on bottom line */
+
+      case 0:
+      case 2:
+      case 3:
+      case 5:
+      case 6:
+      case 8:
+         *p++='_';
+         break;
+      default:
+         *p++=' ';
+
+   }
+   switch(d){
+
+      /* those that have closing | on bottom line */
+
+      case 0:
+      case 1:
+      case 3:
+      case 4:
+      case 5:
+      case 6:
+      case 7:
+      case 8:
+      case 9:
+         *p++='|';
+         break;
+      default:
+         *p++=' ';
+
+   }
+}
+
+/* Write the led representation of integer to string buffer. */
+
+void print_led(unsigned long x, char *buf)
+{
+
+   int i=0,n;
+   static int d[MAX_DIGITS];
+
+
+   /* extract digits from x */
+
+   n = ( x == 0L ? 1 : 0 );  /* 0 is a digit, hence a special case */
+
+   while(x){
+      d[n++] = (int)(x%10L);
+      if(n >= MAX_DIGITS)break;
+      x = x/10L;
+   }
+
+   /* print top lines of all digits */
+
+   for(i=n-1;i>=0;i--){
+      topline(d[i],buf);
+      buf += 3;
+      *buf++=' ';
+   }
+   *buf++='\n'; /* move teletype to next line */
+
+   /* print middle lines of all digits */
+
+   for(i=n-1;i>=0;i--){
+      midline(d[i],buf);
+      buf += 3;
+      *buf++=' ';
+   }
+   *buf++='\n';
+
+   /* print bottom lines of all digits */
+
+   for(i=n-1;i>=0;i--){
+      botline(d[i],buf);
+      buf += 3;
+      *buf++=' ';
+   }
+   *buf++='\n';
+   *buf='\0';
+}
+
+int main()
+{
+   char buf[5*MAX_DIGITS];
+   print_led(1234567, buf);
+   printf("%s\n",buf);
+
+   return 0;
+}
+
+#ifndef NO_MAIN
+int main(int argc, char **argv)
+{
+
+   int i=0,n;
+   long x;
+   static int d[MAX_DIGITS];
+   char buf[5*MAX_DIGITS];
+
+   if(argc != 2){
+      fprintf(stderr,"led: usage: led integer\n");
+      return 1;
+   }
+
+   /* fetch argument from command line */
+
+   x = atol(argv[1]);
+
+   /* sanity check */
+
+   if(x<0){
+      fprintf(stderr,"led: %d must be non-negative\n",x);
+      return 1;
+   }
+
+   print_led(x,buf);
+   printf("%s\n",buf);
+
+   return 0;
+
+}
+#endif
+
+/* vim: set expandtab ts=4 sw=3 sts=3 tw=80 :*/
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/32_led.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/32_led.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/32_led.expect	(revision 331)
@@ -0,0 +1,4 @@
+     _   _       _       _  
+  |  _|  _| |_| |_  |_    | 
+  | |_   _|   |  _| |_|   | 
+
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/33_ternary_op.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/33_ternary_op.c	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/33_ternary_op.c	(revision 331)
@@ -0,0 +1,15 @@
+#include <stdio.h>
+
+int main()
+{
+   int Count;
+
+   for (Count = 0; Count < 10; Count++)
+   {
+      printf("%d\n", (Count < 5) ? (Count*Count) : (Count * 3));
+   }
+
+   return 0;
+}
+
+/* vim: set expandtab ts=4 sw=3 sts=3 tw=80 :*/
Index: EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/33_ternary_op.expect
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/33_ternary_op.expect	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/tests/tests2/33_ternary_op.expect	(revision 331)
@@ -0,0 +1,10 @@
+0
+1
+4
+9
+16
+15
+18
+21
+24
+27
